import { MsgSetFeeTokens } from "./tx";
export const registry = [["/osmosis.txfees.v1beta1.MsgSetFeeTokens", MsgSetFeeTokens]];
export const load = (protoRegistry) => {
    registry.forEach(([typeUrl, mod]) => {
        protoRegistry.register(typeUrl, mod);
    });
};
export const MessageComposer = {
    encoded: {
        setFeeTokens(value) {
            return {
                typeUrl: "/osmosis.txfees.v1beta1.MsgSetFeeTokens",
                value: MsgSetFeeTokens.encode(value).finish()
            };
        }
    },
    withTypeUrl: {
        setFeeTokens(value) {
            return {
                typeUrl: "/osmosis.txfees.v1beta1.MsgSetFeeTokens",
                value
            };
        }
    },
    fromPartial: {
        setFeeTokens(value) {
            return {
                typeUrl: "/osmosis.txfees.v1beta1.MsgSetFeeTokens",
                value: MsgSetFeeTokens.fromPartial(value)
            };
        }
    }
};
