import { GeneratedType, Registry } from "@cosmjs/proto-signing";
import { MsgAddAuthenticator, MsgRemoveAuthenticator, MsgSetActiveState } from "./tx";
export declare const registry: ReadonlyArray<[string, GeneratedType]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        addAuthenticator(value: MsgAddAuthenticator): {
            typeUrl: string;
            value: Uint8Array;
        };
        removeAuthenticator(value: MsgRemoveAuthenticator): {
            typeUrl: string;
            value: Uint8Array;
        };
        setActiveState(value: MsgSetActiveState): {
            typeUrl: string;
            value: Uint8Array;
        };
    };
    withTypeUrl: {
        addAuthenticator(value: MsgAddAuthenticator): {
            typeUrl: string;
            value: MsgAddAuthenticator;
        };
        removeAuthenticator(value: MsgRemoveAuthenticator): {
            typeUrl: string;
            value: MsgRemoveAuthenticator;
        };
        setActiveState(value: MsgSetActiveState): {
            typeUrl: string;
            value: MsgSetActiveState;
        };
    };
    fromPartial: {
        addAuthenticator(value: MsgAddAuthenticator): {
            typeUrl: string;
            value: MsgAddAuthenticator;
        };
        removeAuthenticator(value: MsgRemoveAuthenticator): {
            typeUrl: string;
            value: MsgRemoveAuthenticator;
        };
        setActiveState(value: MsgSetActiveState): {
            typeUrl: string;
            value: MsgSetActiveState;
        };
    };
};
