"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClientImpl = exports.MsgClientImpl = void 0;
const binary_1 = require("../../../binary");
const tx_1 = require("./tx");
class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
        this.setFeeTokens = this.setFeeTokens.bind(this);
    }
    setFeeTokens(request) {
        const data = tx_1.MsgSetFeeTokens.encode(request).finish();
        const promise = this.rpc.request("osmosis.txfees.v1beta1.Msg", "SetFeeTokens", data);
        return promise.then(data => tx_1.MsgSetFeeTokensResponse.decode(new binary_1.BinaryReader(data)));
    }
}
exports.MsgClientImpl = MsgClientImpl;
const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
exports.createClientImpl = createClientImpl;
